-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["MONK"] = {}
local t,s,n
lib.classes["MONK"][1] = function() --Brewmaster
	lib.SetAltPower(SPELL_POWER_CHI,CHI_COST)
	lib.AddSpell("Keg",{121253},true) --Keg Smash
	lib.AddSpell("Haze",{115180}) --Dizzying Haze
	lib.AddAuras("Haze",{123727,116330},"debuff","target") -- Dizzying Haze (123727 - Keg, 116330 - Dizzying Haze)
	lib.AddAura("Weakened",115798,"debuff","target","any") -- Weakened Blows
	lib.AddSpell("Breath",{115181}) -- Breath of Fire
	lib.AddAura("Breath",123725,"debuff","target") -- Breath of Fire
	lib.AddSpell("Guard",{115295}) -- Guard
	lib.AddAura("Guard",115295,"buff","player") -- Guard
	lib.AddAura("Power_Guard",118636,"buff","player") -- Power_Guard
	lib.AddAura("Shuffle",115307,"buff","player") -- Shuffle
	lib.AddSpell("Brew",{115308}) -- Elusive Brew
	lib.AddAura("Brew",128939,"buff","player") -- Elusive Brew stacks
	lib.AddAura("Brew_buff",115308,"buff","player") -- Elusive Brew buff
	lib.AddSpell("Purifying",{119582}) -- Purifying Brew
	--lib.AddAura("Stagger2",124274,"debuff","player") -- Moderate Stagger
	--lib.AddAura("Stagger3",124273,"debuff","player") -- Heavy Stagger
	lib.AddAuras("Stagger",{124274,124273},"debuff","player")
	
	lib.SetDOT("Breath")
	
	lib.SetBUFF("Shuffle")
	lib.SetAuraFunction("Shuffle","OnApply",function()
		lib.UpdateBUFF(UnitGUID("player"),0)
	end)
	lib.SetAuraFunction("Shuffle","OnFade",function()
		lib.UpdateBUFF(UnitGUID("player"))
	end)
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Death")
	table.insert(cfg.plistdps,"SHS")
	table.insert(cfg.plistdps,"Detocs")
	table.insert(cfg.plistdps,"LotWT_nobuff")
	table.insert(cfg.plistdps,"Purifying_Stagger")
	table.insert(cfg.plistdps,"Kick_noShuffle")
	table.insert(cfg.plistdps,"Palm_noPower")
	table.insert(cfg.plistdps,"Guard_noGuard")
	table.insert(cfg.plistdps,"Brew_noBrew")
	--table.insert(cfg.plistdps,"Sphere_noSphere")
	--table.insert(cfg.plistdps,"Breath_noBreath")
	table.insert(cfg.plistdps,"Kick_3chi")
	table.insert(cfg.plistdps,"Chi_Wave")
	table.insert(cfg.plistdps,"Keg")
	table.insert(cfg.plistdps,"Expel")
	table.insert(cfg.plistdps,"Jab")
	if IsPlayerSpell(117967) then
		table.insert(cfg.plistdps,"Palm")
	end
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"SHS")
	table.insert(cfg.plistaoe,"Detocs")
	table.insert(cfg.plistaoe,"LotWT_nobuff")
	table.insert(cfg.plistaoe,"Purifying_Stagger")
	table.insert(cfg.plistaoe,"Palm_noPower")
	table.insert(cfg.plistaoe,"Sphere_noSphere")
	table.insert(cfg.plistaoe,"Kick_noShuffle")
	table.insert(cfg.plistaoe,"Breath_noBreath")
	table.insert(cfg.plistaoe,"Guard_noGuard")
	table.insert(cfg.plistaoe,"Brew_noBrew")
	table.insert(cfg.plistaoe,"Keg")
	table.insert(cfg.plistaoe,"Spin")
	table.insert(cfg.plistaoe,"Chi_Wave")
	table.insert(cfg.plistaoe,"Expel")
	table.insert(cfg.plistaoe,"Jab_aoe")
	if IsPlayerSpell(117967) then
		table.insert(cfg.plistaoe,"Palm")
	end
	table.insert(cfg.plistaoe,"end")
	
	cfg.plist=cfg.plistdps
	
	
	cfg.case = {
		["Guard_noGuard"] = function()
			return lib.SimpleCDCheck("Guard",lib.GetAura({"Guard"})-9)
		end,
		["Kick_noShuffle"] = function()
			return lib.SimpleCDCheck("Kick",lib.GetAura({"Shuffle"})-1.8)
		end,
		["Brew_noBrew"] = function()
			if lib.GetAuraNum("Brew")>=9 then
				return lib.SimpleCDCheck("Brew",lib.GetAura({"Brew_buff"}))
			end
			return nil
		end,
		["Breath_noBreath"] = function()
			return lib.SimpleCDCheck("Breath",lib.GetAura({"Breath"})-2.4)
		end,
		["Purifying_Stagger"] = function()
			if lib.GetAuras("Stagger")>0 then return lib.SimpleCDCheck("Purifying") end
			return nil
		end,
		["Jab_aoe"] = function()
			if cfg.AltPower.max-cfg.AltPower.now>=2 then
				return lib.SimpleCDCheck("Jab",lib.Time2Power(80))
			end
			return nil
		end,
	}
	
	cfg.mode = "dps"
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
	end

	return true
end
lib.classes["MONK"][3] = function() --Windwalker
	lib.SetAltPower(SPELL_POWER_CHI,CHI_COST)
	
	lib.AddSpell("RSK",{107428}) --Rising Sun Kick
	lib.AddAura("RSK",130320,"debuff","target") -- Rising Sun Kick
	lib.AddAura("CBTP",118864,"buff","player") -- Combo Breaker: Tiger Palm
	lib.AddAura("CBBK",116768,"buff","player") -- Combo Breaker: Blackout Kick
	lib.AddAura("CBCE",159407,"buff","player") -- Combo Breaker: Chi Explosion
	lib.AddSpell("Palm",{100787}) --Tiger Palm
	lib.AddAura("Power",125359,"buff","player") -- Tiger Power
	lib.AddSpell("Kick",{100784}) --Blackout Kick
	lib.AddSpell("TB",{116740}) -- Tigereye Brew
	lib.AddAura("TB",125195,"buff","player") -- Tigereye Brew
	lib.AddAura("TBB",116740,"buff","player") -- Tigereye Brew
	lib.AddSpell("Sphere",{124081}) -- Zen Sphere
	lib.AddAura("Sphere",124081,"buff","player") -- Zen Sphere
	lib.AddSpell("Xuen",{123904}) --Invoke Xuen, the White Tiger
	lib.AddSpell("Fortifying",{115203}) -- Fortifying Brew
	lib.AddSpell("Fists",{113656}) -- Fists of Fury
	lib.AddSpell("EB",{115288}) -- Energizing Brew
	lib.AddAura("EB",115288,"buff","player") -- Energizing Brew
	lib.AddSpell("Chi_Brew",{115399}) -- Chi Brew
	lib.AddSpell("Serenity",{152173}) -- Serenity
	lib.AddAura("Serenity",152173,"buff","player") -- Serenity
	
	lib.SetBUFF("Serenity")
	lib.SetAuraFunction("Serenity","OnApply",function()
		lib.UpdateBUFF(UnitGUID("player"),0)
	end)
	lib.SetAuraFunction("Serenity","OnFade",function()
		lib.UpdateBUFF(UnitGUID("player"))
	end)
	
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"SHS")
	table.insert(cfg.plistdps,"Detocs")
	table.insert(cfg.plistdps,"LotWT_nobuff")
	table.insert(cfg.plistdps,"Xuen")
	table.insert(cfg.plistdps,"Chi_Brew")
	table.insert(cfg.plistdps,"Death")
	table.insert(cfg.plistdps,"TB_10TB")
	table.insert(cfg.plistdps,"Palm_noPower")
	table.insert(cfg.plistdps,"RSK_noRSK")
	table.insert(cfg.plistdps,"Chi_CB")
	table.insert(cfg.plistdps,"Kick_CB")
	table.insert(cfg.plistdps,"Palm_CB")
	table.insert(cfg.plistdps,"Serenity")
	table.insert(cfg.plistdps,"Fists_single")
	table.insert(cfg.plistdps,"RSK")
	table.insert(cfg.plistdps,"Chi_Wave")
	table.insert(cfg.plistdps,"Expel")
	table.insert(cfg.plistdps,"Jab")
	table.insert(cfg.plistdps,"Kick_3chi")
	table.insert(cfg.plistdps,"EB")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"SHS")
	table.insert(cfg.plistaoe,"Detocs")
	table.insert(cfg.plistaoe,"LotWT_nobuff")
	table.insert(cfg.plistaoe,"RSK_noRSK_aoe")
	table.insert(cfg.plistaoe,"Palm_noPower_aoe")
	table.insert(cfg.plistaoe,"RSK_aoe")
	table.insert(cfg.plistaoe,"Fists_aoe")
	table.insert(cfg.plistaoe,"Spin")
	table.insert(cfg.plistaoe,"Jab")
	table.insert(cfg.plistaoe,"CB_aoe")
	table.insert(cfg.plistaoe,"EB_aoe")
	table.insert(cfg.plistaoe,"end")
	
	
	cfg.plist=cfg.plistdps
	
	
	cfg.case = {
		["Chi_Brew"] = function()
			if (cfg.AltPower.max-cfg.AltPower.now)>=2 and lib.GetAuraNum("TB")<=16 and cfg.Power.now<cfg.Power.max then
				return lib.SimpleCDCheck("Chi_Brew")
			end
			return nil
		end,
		["CB"] = function()
			if lib.GetAura({"CBTP"})>0 then
				return lib.SimpleCDCheck("Palm")
			end
			if lib.GetAura({"CBBK"})>0 then
				return lib.SimpleCDCheck("Kick")
			end
			if lib.GetAura({"CBCE"})>0 and cfg.AltPower.now>=3 then
				return lib.SimpleCDCheck("Kick")
			end
			
			return nil
		end,
		["Palm_CB"] = function()
			if lib.GetAura({"CBTP"})>lib.GetSpellCD("Palm") then
				return lib.SimpleCDCheck("Palm")
			end
			return nil
		end,
		["Kick_CB"] = function()
			if lib.GetAura({"CBBK"})>lib.GetSpellCD("Kick") then
				return lib.SimpleCDCheck("Kick")
			end
			return nil
		end,
		["Chi_CB"] = function()
			if lib.GetAura({"CBCE"})>lib.GetSpellCD("Kick") and cfg.AltPower.now>=3 then
				return lib.SimpleCDCheck("Kick")
			end
			return nil
		end,
		
		["EB"] = function()
			if cfg.Power.real<40 and lib.GetSpellCD("Fists")>lib.GetSpellCD("EB")+6 then
				return lib.SimpleCDCheck("EB")
			end
			return nil
		end,
		
		["Fortifying"] = function()
			if not lib.hardtarget() then return nil end
			if lib.GetAura({"Death"})>0 then
				return lib.SimpleCDCheck("Fortifying")
			end
			return nil
		end,
		
		["TB_10TB"] = function()
			if lib.hardtarget() and lib.GetAuraNum("TB")>=10 then
				return lib.SimpleCDCheck("TB",lib.GetAura({"TBB"}))
			end
				
			if not lib.hardtarget() and lib.GetAuraNum("TB")==20 then
				return lib.SimpleCDCheck("TB",lib.GetAura({"TBB"}))
			end
			return nil
		end,

		["Palm"] = function()
			if cfg.AltPower.now<2 then return nil end
			if lib.GetAura({"Power"})==0 or lib.GetAuraNum("Power")<3 then
				return lib.SimpleCDCheck("Palm")
			end
			return nil
		end,

		["RSK_noRSK"] = function()
			return lib.SimpleCDCheck("RSK",lib.GetAura({"RSK"})-4.5)
		end,
		
		["Serenity"] = function()
			if lib.GetAura({"Power"})>lib.GetSpellCD("Serenity")+10 and cfg.AltPower.now>=3 then --lib.GetAura({"RSK"})>lib.GetSpellCD("Serenity")+10 
				return lib.SimpleCDCheck("Serenity",lib.GetAura({"EB"}))
			end
			return nil
		end,
		["Fists_single"] = function()
			if lib.GetAura({"Power"})+3>lib.GetSpellCD("Fists") and  lib.GetAura({"RSK"})+3>lib.GetSpellCD("Fists") then
				return lib.SimpleCDCheck("Fists",lib.GetAura({"Serenity"}))
			end
			return nil
		end,
		["RSK_noRSK_aoe"] = function()
			if cfg.AltPower.now<2 then return nil end
			return lib.SimpleCDCheck("RSK",lib.GetAura({"RSK"})-4.5,true)
		end,
		["RSK_aoe"] = function()
			if cfg.AltPower.now<2 then return nil end
			return lib.SimpleCDCheck("RSK",nil,true)
		end,
		["Palm_noPower_aoe"] = function()
			if lib.GetAura({"CBTP"})>0 or cfg.AltPower.now>=1 then
				return lib.SimpleCDCheck("Palm",lib.GetAura({"Power"})-2,true)
			end
			return nil
		end,
		["Fists_aoe"] = function()
			if cfg.AltPower.now<3 then return nil end
			return lib.SimpleCDCheck("Fists",nil,true)
		end,
		["CB_aoe"] = function()
			if lib.GetAura({"CBTP"})>0 then
				return lib.SimpleCDCheck("Palm",nil,true)
			end
			if lib.GetAura({"CBBK"})>0 then
				return lib.SimpleCDCheck("Kick",nil,true)
			end
			if lib.GetAura({"CBCE"})>0 and cfg.AltPower.now>=3 then
				return lib.SimpleCDCheck("Kick")
			end
			
			return nil
		end,
		["EB_aoe"] = function()
			if cfg.Power.real<40 then
				return lib.SimpleCDCheck("EB",nil,true)
			end
			return nil
		end,
		
	}
	
	cfg.mode = "dps"
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
	end
	
	cfg.spells_aoe={"Spin1","Spin2"}
	--cfg.spells_single={"Kick"}
	return true
end


lib.classevents["MONK"] = function()
	lib.UpdatePlayerHealth()
	function Heddclassevents.UNIT_HEALTH_FREQUENT(unit)
		if unit=="player" then
			lib.UpdatePlayerHealth()
		end
	end
	
	lib.AddDispellPlayer("Detocs",{115450},{"Disease","Poison"}) --Detocs
	lib.SetInterrupt("SHS",{116705}) --Spear Hand Strike
	
	lib.AddSpell("Palm",{100787}) --Tiger Palm
	lib.AddAura("Power",125359,"buff","player") -- Tiger Power
	cfg.case["Palm_noPower"] = function()
		return lib.SimpleCDCheck("Palm",lib.GetAura({"Power"})-6)
	end
	
	lib.AddSpell("Kick",{152174,100784}) --Blackout Kick
	cfg.case["Kick_3chi"] = function()
		if cfg.AltPower.max-cfg.AltPower.now<=2 then
			return lib.SimpleCDCheck("Kick")
		end
		return nil
	end
	
	lib.AddSpell("Sphere",{124081}) -- Zen Sphere
	lib.AddAura("Sphere",124081,"buff","player") -- Zen Sphere
	lib.AddSpell("Chi_Wave",{115098}) -- Chi-Wave
	cfg.case["Chi_Wave"] = function()
		return lib.SimpleCDCheck("Chi_Wave",lib.GetAura({"Serenity"}))
	end
	
	lib.AddSpell("Death",{115080}) -- Touch of Death
	lib.AddAura("Death",121125,"buff","player") -- Death Note
	cfg.case["Death"] = function()
		if not lib.hardtarget() then return nil end
		if lib.GetAura({"Death"})>lib.GetSpellCD("Death") then
			return lib.SimpleCDCheck("Death")
		end
		return nil
	end

	lib.AddSpell("LotWT",{116781}) -- Legacy of the White Tiger
--	lib.AddAura("LotWT",116781,"buff","player") -- Legacy of the White Tiger
	
	cfg.case["LotWT_nobuff"] = function()
		return lib.SimpleCDCheck("LotWT",math.min(lib.GetAuras("Stats"),lib.GetAuras("Crit")))
	end
	
	lib.AddAura("Power_Strikes",53817,"buff","player")
	lib.AddSpell("Jab",{100780,115693,115695,115687,115698,108557})
	cfg.case["Jab"] = function()
		if cfg.AltPower.max-cfg.AltPower.now>=2 then
			return lib.SimpleCDCheck("Jab")
		end
		return nil
	end
	
	lib.AddSpell("Expel",{115072}) -- Expel Harm
	cfg.case["Expel"] = function()
		if cfg.AltPower.max-cfg.AltPower.now>=2 and cfg.phealthperc<=95 then
			return lib.SimpleCDCheck("Expel")
		end
		return nil
	end
		
		
	lib.AddSpell("Spin2",{116847}) -- Rushing Jade Wind
	lib.AddAura("Spin2",116847,"buff","player") -- Rushing Jade Wind
	lib.AddSpell("Spin1",{101546}) -- Spinning Crane Kick
	lib.AddAura("Spin1",101546,"buff","player") -- Spinning Crane Kick
	lib.AddSpell("Spin",{116847,101546})
		
--[[		cfg.case["Spin"] = function()
			if lib.KnownSpell("Spin2") then
				return lib.SimpleCDCheck("Spin2")
			else 
				return lib.SimpleCDCheck("Spin1")
			end
			return nil
		end]]
		
	cfg.spells_aoe={"Spin1","Spin2"}
	lib.rangecheck=function()
		if lib.inrange("Jab") then
			lib.bdcolor(Heddmain.bd,nil)
		else
			lib.bdcolor(Heddmain.bd,{1,0,0,1})
		end
	end

	lib.CD = function()
		lib.CDadd("SHS")
		lib.CDadd("Detocs")
		lib.CDadd("Death")
		lib.CDadd("Xuen")
		lib.CDadd("Chi_Brew")
		lib.CDadd("Serenity")
		lib.CDadd("Fists")
		lib.CDadd("Chi_Wave")
		lib.CDadd("EB")
		
	end
	--lib.CD()
end